#!/bin/sh
# \
wish=`( for name in $(/bin/ls $(echo $PATH | sed 's/:/ /g') 2> /dev/null | egrep '^wish(step)?([0-9]+\.[0-9]+)([a-z][a-z])?$') ; do echo $name ; done ) | tail -1` ;\
[ -z "$wish" ] && wish=wish ;\
echo "Using $wish" ;\
exec $wish "$0" ${1+"$@"}


load ./TkXext.so

proc do_ls {} {
	sendStringToEmbedded .f XTERM_1 "ls | more\r"
}

proc do_wc {} {
	sendStringToEmbedded .t.f XTERM_2 "wc -l *\r"
}

proc rtxterm {} {
	global pid_list
	#lappend pid_list [exec xterm -T "XTERM_3" -xrm "xterm*allowSendEvents:true" &]
	lappend pid_list [exec rxvt -T XTERM_3 &]
	
	#It needs a short delay, because rxvt may receive the events before 
	#it's ready.  So, the sendString will appear to have done nothing 
	#without it.
	after 1000
	
	sendString XTERM_3 "ps aux | more\r"
}

proc cleanup_exit {} {
	global pid_list

	foreach p $pid_list {
		catch {exec kill $p}
	}
	exit
}

proc main {} {
	global pid_list
	#Make a list of process ids, so that we can cleanup at the end.	
	#With rxvt the -xrm option doesn't need to be used to allow send events.
	#The initial window is positioned off of the screen.
	#lappend pid_list [exec xterm -T "XTERM_1" -iconic -xrm "xterm*allowSendEvents:true" -g +1000+1000 &]
	lappend pid_list [exec rxvt -T XTERM_1 -iconic -g 1000+1000 &]
	pack [frame .f -width 400 -height 400 -container 1] -fill both
	embed -into .f -name XTERM_1
	bind .f <Configure> {stretchWindow %W}
	#lappend pid_list [exec xterm -T "XTERM_2" -iconic -xrm "xterm*allowSendEvents:true" -g +1000+1000 &]

	lappend pid_list [exec rxvt -T XTERM_2 -iconic -g +1000+1000 &]
	toplevel .t
	pack [frame .t.f -width 400 -height 400 -container 1] -fill both
	embed -name XTERM_2 -into .t.f
	bind .t.f <Configure> {stretchWindow %W}

	#You can also use string match type of characters
	#embed -name "Netscape*Teoma*Search" -into .t.f
	pack [button .ls -text {Do ls | more in XTERM_1} -command do_ls] -fill x
	pack [button .wc -text {Do wc -l * in XTERM_2} -command do_wc] -fill x
	pack [button .tex -text {Test Root Parented Xterm Sending} -command rtxterm] -fill x
	pack [button .mp -text {Move Pointer} -command {movePointerTo 200 20}] -fill x
	#Give the code below a try after you have started xev (xev is in the X distribution).
	#pack [button .bp -text {Send Button Press} -command {sendButtonPress "Event Tester" 1 20 20}]
	wm protocol . WM_DELETE_WINDOW cleanup_exit
}
main 
